=== modified file 'Makefile'
--- Makefile	2010-09-10 17:06:26 +0000
+++ Makefile	2009-11-19 18:31:28 +0000
@@ -209,17 +209,6 @@
 
 # Run the client with a local config and key
 run-client: all keydir/seckey.txt keydir/pubkey.txt
-	@echo "###################################################################"
-	@echo "# The following error messages are harmless and can be safely     #"
-	@echo "# ignored.  The messages are caused by not running as root, but   #"
-	@echo "# you should NOT run \"make run-client\" as root unless you also    #"
-	@echo "# unpacked and compiled Mandos as root, which is NOT recommended. #"
-	@echo "# From plugin-runner: setuid: Operation not permitted             #"
-	@echo "# From askpass-fifo:  mkfifo: Permission denied                   #"
-	@echo "# From mandos-client: setuid: Operation not permitted             #"
-	@echo "#                     seteuid: Operation not permitted            #"
-	@echo "#                     klogctl: Operation not permitted            #"
-	@echo "###################################################################"
 	./plugin-runner --plugin-dir=plugins.d \
 		--config-file=plugin-runner.conf \
 		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt \
@@ -232,13 +221,6 @@
 
 # Run the server with a local config
 run-server: confdir/mandos.conf confdir/clients.conf
-	@echo "#################################################################"
-	@echo "# NOTE: Please IGNORE errors about \"No permission to bind to    #"
-	@echo "# interface\" or \"Could not open file u'/var/run/mandos.pid'\" -  #"
-	@echo "# they are harmless and are caused by the server not running as #"
-	@echo "# root.  Do NOT run \"make run-server\" server as root if you did #"
-	@echo "# not also unpack and compile it as root.                       #"
-	@echo "#################################################################"
 	./mandos --debug --no-dbus --configdir=confdir $(SERVERARGS)
 
 # Used by run-server
@@ -265,8 +247,6 @@
 		mandos.conf
 	install --mode=u=rw --target-directory=$(CONFDIR) \
 		clients.conf
-	install --mode=u=rw,go=r dbus-mandos.conf \
-		$(DESTDIR)/etc/dbus-1/system.d/mandos.conf
 	install --mode=u=rwx,go=rx init.d-mandos \
 		$(DESTDIR)/etc/init.d/mandos
 	install --mode=u=rw,go=r default-mandos \
@@ -376,7 +356,6 @@
 
 purge-server: uninstall-server
 	-rm --force $(CONFDIR)/mandos.conf $(CONFDIR)/clients.conf \
-		$(DESTDIR)/etc/dbus-1/system.d/mandos.conf
 		$(DESTDIR)/etc/default/mandos \
 		$(DESTDIR)/etc/init.d/mandos \
 		$(DESTDIR)/var/run/mandos.pid

=== modified file 'TODO'
--- TODO	2010-09-09 18:16:14 +0000
+++ TODO	2010-06-19 00:37:04 +0000
@@ -1,6 +1,6 @@
 -*- org -*-
 
-* Use _attribute_((nonnull)) wherever possible.
+* _attribute_((nonnull))
 
 * mandos-client
 ** TODO [#B] use scandir(3) instead of readdir(3)
@@ -40,7 +40,8 @@
 ** TODO [#C] use same file name rules as run-parts(8)
 ** kernel command line option for debug info
 ** TODO [#B] use error() instead of perror()
-** TODO [#B] Use openat()
+** TODO [$B] Use openat() and readdir64()
+   http://udrepper.livejournal.com/19395.html
 
 * mandos (server)
 ** TODO [#B] Log level							  :BUGS:
@@ -74,11 +75,11 @@
 ** More D-Bus methods
 *** NeedsApproval(50, True) -> timeout, default approve
     Default approval is configurable, but True by default
-    + Approve(True) -> approve sending saved
-    + Approve(False) -> Close client connection immediately
+    + Approval(True) -> approve sending saved
+    + Approval(False) -> Close client connection immediately
 *** NeedsPassword(50) - Timeout, default disapprove
     + SetPass(u"gazonk", True) -> Approval, persistent
-    + Approve(False) -> Close client connection immediately
+    + Approval(False) -> Close client connection immediately
 ** TODO [#C] python-parsedatetime
 ** TODO [#C] systemd/launchd
    http://0pointer.de/blog/projects/systemd.html

=== modified file 'mandos'
--- mandos	2010-09-09 18:16:14 +0000
+++ mandos	2010-06-19 00:37:04 +0000
@@ -193,7 +193,7 @@
         self.group.Commit()
     def entry_group_state_changed(self, state, error):
         """Derived from the Avahi example code"""
-        logger.debug(u"Avahi entry group state change: %i", state)
+        logger.debug(u"Avahi state change: %i", state)
         
         if state == avahi.ENTRY_GROUP_ESTABLISHED:
             logger.debug(u"Zeroconf service established.")
@@ -212,7 +212,6 @@
             self.group = None
     def server_state_changed(self, state):
         """Derived from the Avahi example code"""
-        logger.debug(u"Avahi server state change: %i", state)
         if state == avahi.SERVER_COLLISION:
             logger.error(u"Zeroconf server name collision")
             self.remove()
@@ -1565,8 +1564,7 @@
     tcp_server = MandosServer((server_settings[u"address"],
                                server_settings[u"port"]),
                               ClientHandler,
-                              interface=(server_settings[u"interface"]
-                                         or None),
+                              interface=server_settings[u"interface"],
                               use_ipv6=use_ipv6,
                               gnutls_priority=
                               server_settings[u"priority"],

=== modified file 'mandos-monitor'
--- mandos-monitor	2010-09-05 20:19:02 +0000
+++ mandos-monitor	2009-12-25 23:13:47 +0000
@@ -37,22 +37,6 @@
 urwid.curses_display.curses.A_UNDERLINE |= (
     urwid.curses_display.curses.A_BLINK)
 
-def isoformat_to_datetime(iso):
-    "Parse an ISO 8601 date string to a datetime.datetime()"
-    if not iso:
-        return None
-    d, t = iso.split(u"T", 1)
-    year, month, day = d.split(u"-", 2)
-    hour, minute, second = t.split(u":", 2)
-    second, fraction = divmod(float(second), 1)
-    return datetime.datetime(int(year),
-                             int(month),
-                             int(day),
-                             int(hour),
-                             int(minute),
-                             int(second),           # Whole seconds
-                             int(fraction*1000000)) # Microseconds
-
 class MandosClientPropertyCache(object):
     """This wraps a Mandos Client D-Bus proxy object, caches the
     properties and calls a hook function when any of them are
@@ -66,7 +50,7 @@
                                      self.property_changed,
                                      client_interface,
                                      byte_arrays=True)
-        
+
         self.properties.update(
             self.proxy.GetAll(client_interface,
                               dbus_interface = dbus.PROPERTIES_IFACE))
@@ -96,9 +80,6 @@
         # Logger
         self.logger = logger
         
-        self._update_timer_callback_tag = None
-        self.last_checker_failed = False
-        
         # The widget shown normally
         self._text_widget = urwid.Text(u"")
         # The widget shown when we have focus
@@ -124,55 +105,30 @@
                                      self.rejected,
                                      client_interface,
                                      byte_arrays=True)
-        last_checked_ok = isoformat_to_datetime(self.properties
-                                                ["last_checked_ok"])
-        if last_checked_ok is None:
-            self.last_checker_failed = True
-        else:
-            self.last_checker_failed = ((datetime.datetime.utcnow()
-                                         - last_checked_ok)
-                                        > datetime.timedelta
-                                        (milliseconds=
-                                         self.properties["interval"]))
-        if self.last_checker_failed:
-            self._update_timer_callback_tag = (gobject.timeout_add
-                                               (1000,
-                                                self.update_timer))
     
     def checker_completed(self, exitstatus, condition, command):
         if exitstatus == 0:
-            if self.last_checker_failed:
-                self.last_checker_failed = False
-                gobject.source_remove(self._update_timer_callback_tag)
-                self._update_timer_callback_tag = None
             self.logger(u'Checker for client %s (command "%s")'
                         u' was successful'
                         % (self.properties[u"name"], command))
-            self.update()
             return
-        # Checker failed
-        if not self.last_checker_failed:
-            self.last_checker_failed = True
-            self._update_timer_callback_tag = (gobject.timeout_add
-                                               (1000,
-                                                self.update_timer))
         if os.WIFEXITED(condition):
             self.logger(u'Checker for client %s (command "%s")'
                         u' failed with exit code %s'
                         % (self.properties[u"name"], command,
                            os.WEXITSTATUS(condition)))
-        elif os.WIFSIGNALED(condition):
+            return
+        if os.WIFSIGNALED(condition):
             self.logger(u'Checker for client %s (command "%s")'
                         u' was killed by signal %s'
                         % (self.properties[u"name"], command,
                            os.WTERMSIG(condition)))
-        elif os.WCOREDUMP(condition):
+            return
+        if os.WCOREDUMP(condition):
             self.logger(u'Checker for client %s (command "%s")'
                         u' dumped core'
                         % (self.properties[u"name"], command))
-        else:
-            self.logger(u'Checker for client %s completed mysteriously')
-        self.update()
+        self.logger(u'Checker for client %s completed mysteriously')
     
     def checker_started(self, command):
         self.logger(u'Client %s started checker "%s"'
@@ -214,29 +170,12 @@
                           }
         
         # Rebuild focus and non-focus widgets using current properties
-        self._text = (u'%(name)s: %(enabled)s%(timer)s'
+        self._text = (u'%(name)s: %(enabled)s'
                       % { u"name": self.properties[u"name"],
                           u"enabled":
                               (u"enabled"
                                if self.properties[u"enabled"]
-                               else u"DISABLED"),
-                          u"timer": (unicode(datetime.timedelta
-                                             (milliseconds =
-                                              self.properties
-                                              [u"timeout"])
-                                             - (datetime.datetime
-                                                .utcnow()
-                                                - isoformat_to_datetime
-                                                (max((self.properties
-                                                 ["last_checked_ok"]
-                                                 or
-                                                 self.properties
-                                                 ["created"]),
-                                                    self.properties[u"last_enabled"]))))
-                                     if (self.last_checker_failed
-                                         and self.properties
-                                         [u"enabled"])
-                                     else u"")})
+                               else u"DISABLED")})
         if not urwid.supports_unicode():
             self._text = self._text.encode("ascii", "replace")
         textlist = [(u"normal", self._text)]
@@ -253,15 +192,7 @@
         if self.update_hook is not None:
             self.update_hook()
     
-    def update_timer(self):
-        "called by gobject"
-        self.update()
-        return True             # Keep calling this
-    
     def delete(self):
-        if self._update_timer_callback_tag is not None:
-            gobject.source_remove(self._update_timer_callback_tag)
-            self._update_timer_callback_tag = None
         if self.delete_hook is not None:
             self.delete_hook(self)
     

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2010-09-09 18:16:14 +0000
+++ plugins.d/mandos-client.c	2009-11-01 00:10:28 +0000
@@ -127,8 +127,6 @@
 static const char mandos_protocol_version[] = "1";
 const char *argp_program_version = "mandos-client " VERSION;
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
-static const char sys_class_net[] = "/sys/class/net";
-char *connect_to = NULL;
 
 /* Used for passing in values through the Avahi callback functions */
 typedef struct {
@@ -1022,101 +1020,6 @@
   errno = old_errno;
 }
 
-/* 
- * This function determines if a directory entry in /sys/class/net
- * corresponds to an acceptable network device.
- * (This function is passed to scandir(3) as a filter function.)
- */
-int good_interface(const struct dirent *if_entry){
-  ssize_t ssret;
-  char *flagname = NULL;
-  int ret = asprintf(&flagname, "%s/%s/flags", sys_class_net,
-		     if_entry->d_name);
-  if(ret < 0){
-    perror("asprintf");
-    return 0;
-  }
-  if(if_entry->d_name[0] == '.'){
-    return 0;
-  }
-  int flags_fd = (int)TEMP_FAILURE_RETRY(open(flagname, O_RDONLY));
-  if(flags_fd == -1){
-    perror("open");
-    return 0;
-  }
-  typedef short ifreq_flags;	/* ifreq.ifr_flags in netdevice(7) */
-  /* read line from flags_fd */
-  ssize_t to_read = (sizeof(ifreq_flags)*2)+3; /* "0x1003\n" */
-  char *flagstring = malloc((size_t)to_read+1); /* +1 for final \0 */
-  flagstring[(size_t)to_read] = '\0';
-  if(flagstring == NULL){
-    perror("malloc");
-    close(flags_fd);
-    return 0;
-  }
-  while(to_read > 0){
-    ssret = (ssize_t)TEMP_FAILURE_RETRY(read(flags_fd, flagstring,
-					     (size_t)to_read));
-    if(ssret == -1){
-      perror("read");
-      free(flagstring);
-      close(flags_fd);
-      return 0;
-    }
-    to_read -= ssret;
-    if(ssret == 0){
-      break;
-    }
-  }
-  close(flags_fd);
-  intmax_t tmpmax;
-  char *tmp;
-  errno = 0;
-  tmpmax = strtoimax(flagstring, &tmp, 0);
-  if(errno != 0 or tmp == flagstring or (*tmp != '\0'
-					 and not (isspace(*tmp)))
-     or tmpmax != (ifreq_flags)tmpmax){
-    if(debug){
-      fprintf(stderr, "Invalid flags \"%s\" for interface \"%s\"\n",
-	      flagstring, if_entry->d_name);
-    }
-    free(flagstring);
-    return 0;
-  }
-  free(flagstring);
-  ifreq_flags flags = (ifreq_flags)tmpmax;
-  /* Reject the loopback device */
-  if(flags & IFF_LOOPBACK){
-    if(debug){
-      fprintf(stderr, "Rejecting loopback interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 0;
-  }
-  /* Accept point-to-point devices only if connect_to is specified */
-  if(connect_to != NULL and (flags & IFF_POINTOPOINT)){
-    if(debug){
-      fprintf(stderr, "Accepting point-to-point interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 1;
-  }
-  /* Otherwise, reject non-broadcast-capable devices */
-  if(not (flags & IFF_BROADCAST)){
-    if(debug){
-      fprintf(stderr, "Rejecting non-broadcast interface \"%s\"\n",
-	      if_entry->d_name);
-    }
-    return 0;
-  }
-  /* Accept this device */
-  if(debug){
-    fprintf(stderr, "Interface \"%s\" is acceptable\n",
-	    if_entry->d_name);
-  }
-  return 1;
-}
-
 int main(int argc, char *argv[]){
   AvahiSServiceBrowser *sb = NULL;
   int error;
@@ -1124,12 +1027,13 @@
   intmax_t tmpmax;
   char *tmp;
   int exitcode = EXIT_SUCCESS;
-  const char *interface = "";
+  const char *interface = "eth0";
   struct ifreq network;
   int sd = -1;
   bool take_down_interface = false;
   uid_t uid;
   gid_t gid;
+  char *connect_to = NULL;
   char tempdir[] = "/tmp/mandosXXXXXX";
   bool tempdir_created = false;
   AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
@@ -1292,31 +1196,6 @@
   if(not debug){
     avahi_set_log_function(empty_log);
   }
-
-  if(interface[0] == '\0'){
-    struct dirent **direntries;
-    ret = scandir(sys_class_net, &direntries, good_interface,
-		  alphasort);
-    if(ret >= 1){
-      /* Pick the first good interface */
-      interface = strdup(direntries[0]->d_name);
-      if(debug){
-	fprintf(stderr, "Using interface \"%s\"\n", interface);
-      }
-      if(interface == NULL){
-	perror("malloc");
-	free(direntries);
-	exitcode = EXIT_FAILURE;
-	goto end;
-      }
-      free(direntries);
-    } else {
-      free(direntries);
-      fprintf(stderr, "Could not find a network interface\n");
-      exitcode = EXIT_FAILURE;
-      goto end;
-    }
-  }
   
   /* Initialize Avahi early so avahi_simple_poll_quit() can be called
      from the signal handler */
@@ -1393,7 +1272,7 @@
   }
   
   /* If the interface is down, bring it up */
-  if(strcmp(interface, "none") != 0){
+  if(interface[0] != '\0'){
     if_index = (AvahiIfIndex) if_nametoindex(interface);
     if(if_index == 0){
       fprintf(stderr, "No such interface: \"%s\"\n", interface);
@@ -1470,7 +1349,7 @@
       ret = ioctl(sd, SIOCSIFFLAGS, &network);
       if(ret == -1){
 	take_down_interface = false;
-	perror("ioctl SIOCSIFFLAGS +IFF_UP");
+	perror("ioctl SIOCSIFFLAGS");
 	exitcode = EX_OSERR;
 #ifdef __linux__
 	if(restore_loglevel){
@@ -1745,7 +1624,7 @@
 	network.ifr_flags &= ~(short)IFF_UP; /* clear flag */
 	ret = ioctl(sd, SIOCSIFFLAGS, &network);
 	if(ret == -1){
-	  perror("ioctl SIOCSIFFLAGS -IFF_UP");
+	  perror("ioctl SIOCSIFFLAGS");
 	}
       }
       ret = (int)TEMP_FAILURE_RETRY(close(sd));

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2010-08-10 19:08:24 +0000
+++ plugins.d/mandos-client.xml	2009-02-09 02:01:13 +0000
@@ -202,9 +202,8 @@
 	<listitem>
 	  <para>
 	    Network interface that will be brought up and scanned for
-	    Mandos servers to connect to.  The default is the empty
-	    string, which will automatically choose an appropriate
-	    interface.
+	    Mandos servers to connect to.  The default is
+	    <quote><literal>eth0</literal></quote>.
 	  </para>
 	  <para>
 	    If the <option>--connect</option> option is used, this
@@ -221,11 +220,10 @@
 	    by this program.
 	  </para>
 	  <para>
-	    <replaceable>NAME</replaceable> can be the string
-	    <quote><literal>none</literal></quote>; this will not use
-	    any specific interface, and will not bring up an interface
-	    on startup.  This is not recommended, and only meant for
-	    advanced users.
+	    <replaceable>NAME</replaceable> can be the empty string;
+	    this will not use any specific interface, and will not
+	    bring up an interface on startup.  This is not
+	    recommended, and only meant for advanced users.
 	  </para>
 	</listitem>
       </varlistentry>

